package com.gyan.rs;

import java.io.IOException;

import org.apache.commons.codec.binary.Base64;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.methods.GetMethod;
import org.gyan.GSSClient;
import org.ietf.jgss.GSSException;

public class Client1 {

	private static GSSClient gssClient;

	/**
	 * @param args
	 * @throws IOException
	 * @throws HttpException
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws HttpException, IOException, InterruptedException {
		
		String theClientCred = authenticateAndGetKerberosToken();
		
		
			String serviceAddress = "http://localhost:9000/echoservice/";
			String message = "Hi man, how are u?";
			System.out.println(message);
			try {
				byte[] wrapedMsg = gssClient.wrapMessage(message.getBytes());
				serviceAddress += Base64.encodeBase64URLSafeString(wrapedMsg);
			} catch (GSSException e) {
				e.printStackTrace();
			}
			GetMethod get = new GetMethod(serviceAddress);

			get.setRequestHeader("Authorization", theClientCred);
			HttpClient httpclient = new HttpClient();

			try {
				int result = httpclient.executeMethod(get);
				System.out.println("Response status code: " + result);
				System.out.println("Response body: ");
				System.out.println("Return message from server as is: "
						+ get.getResponseBodyAsString());
				System.out.println("After decryptionm: "
						+ new String(gssClient.unWrapMessage(Base64
								.decodeBase64(get.getResponseBodyAsString()))));
			} catch (GSSException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} finally {
				// Release current connection to the connection pool once you are done
				get.releaseConnection();
			}
//			Thread.sleep(10000);
		}

	private static String authenticateAndGetKerberosToken() {
		gssClient = new GSSClient("monkey", "Password99");
		String serviceTicket = Base64.encodeBase64URLSafeString(gssClient.login());
		return serviceTicket;
	}
}//End of Class
