package com.gyan.rs;

import javax.ws.rs.DefaultValue;
import javax.ws.rs.GET;
import javax.ws.rs.HeaderParam;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;

import org.apache.commons.codec.binary.Base64;
import org.gyan.server.GSSServer;
import org.ietf.jgss.GSSException;

@Path("/echoservice/")
public class EchoService {

	private GSSServer gssServer;	
	public EchoService(){
		gssServer = new GSSServer();
        gssServer.startServer();
	}
	@GET
	@Path("/{msg}/")
	public String saySomthing(@PathParam("msg") String clientMsg, @DefaultValue("NA") 
			@HeaderParam("Authorization") String kerberosToken) throws GSSException {
		
		System.out.println("auth:"+ kerberosToken);
		System.out.println("Encrypted message as is: "+ clientMsg);
		byte[] convert = Base64.decodeBase64(kerberosToken);
		try {
			gssServer.authenticate(convert);
			byte[] unWrapMessage = gssServer.unWrapMessage(Base64.decodeBase64(clientMsg));
			clientMsg = new String(unWrapMessage);
		} catch (GSSException e) {
			e.printStackTrace();
		}
		System.out.println("Decrypted Msg: "+ clientMsg);
		return  Base64.encodeBase64URLSafeString(gssServer.wrapMessage(("You said '" + clientMsg + "'").getBytes()));
	}	
}
